// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import net.cellcomputing.himawari.accessory.STLVector;
import net.cellcomputing.himawari.accessory.primitive.p_float;
import net.cellcomputing.himawari.accessory.primitive.p_int;
import net.cellcomputing.himawari.util.AccessSupplier;


/**
 * 
 * CqMicroPolyGridBaseCqMotionSpec&lt;CqMicroPolyGridBase&gt;̓dpzNXB
 * ŎĂ郁\bh͑SCqMotionSpecŎĂ̂̃Rs[B
 * 
 * @author NTT DATA Corporation
 */
public abstract strictfp class CqMicroPolyGridBaseMotionImple
							extends CqMicroPolyGridBase implements IqMotionSpec<CqMicroPolyGridBase> {
	
	//*******************************************************
	//
	//	Constructor from "CqMicroPolyGridBase"
	//
	//*******************************************************
	
	public CqMicroPolyGridBaseMotionImple() {
		super();
	}
	
	//*******************************************************
	//
	//	Code from "CqMotionSpec"
	//
	//*******************************************************
	
	//^CXbgB
	//  ^CXbgƂ̓t[ԂۑVectorłB
	protected STLVector<Float>	m_aTimes = new STLVector<Float>( Float.class );	///< Array of float timeslot times.
	protected STLVector<CqMicroPolyGridBase>	m_aObjects;							///< Array of motion objects for each timeslot.
	protected CqMicroPolyGridBase				m_DefObject;						///< Default motion object, used when expanding the list of timeslots
	
	/**
	 * ftHgRXgN^
	 * @param a [VIuWFNg̃ftHg̒lB<br>
	 * 
	 */
	@SuppressWarnings("unchecked")
	protected void CqMotionSpec( final CqMicroPolyGridBase a )
	{
		m_DefObject = a;
		//AddTimeSlot(0.0f, a);
		m_aObjects = new STLVector( CqMicroPolyGridBase.class );
	}
	
	/** 
	 * Rs[RXgN^
	 */
	@SuppressWarnings("unchecked")
	protected void CqMotionSpec( final IqMotionSpec<CqMicroPolyGridBase> From )
	{
		m_aObjects = new STLVector( CqMicroPolyGridBase.class );
		this.assignment( From );
	}
	
	/** 
	 * ZqB<br>
	 * SĂ̗vfRs[B
	 */
	@SuppressWarnings("unchecked")
	public void assignment( final IqMotionSpec<CqMicroPolyGridBase> From )
	{
		m_aTimes.clear();
		m_aObjects.clear();
		
//		m_aTimes.addAll( From.m_aTimes );
//		m_aObjects.addAll( From.m_aObjects );
//		m_DefObject = From.m_DefObject;
		m_aTimes.addAll( (STLVector<Float>)AccessSupplier.getField(From,"m_aTimes") );
		m_aObjects.addAll( (STLVector<CqMicroPolyGridBase>)AccessSupplier.getField(From,"m_aObjects") );
		m_DefObject = (CqMicroPolyGridBase)AccessSupplier.getField(From,"m_DefObject");
	}
	
	/** 
	 * ZqB<br>
	 * SĂ̗vfRs[B
	 */
	@SuppressWarnings("unchecked")
	public void assignment(CqMotionSpec<CqMicroPolyGridBase> From) {
		assignment( (CqMotionSpec<CqMicroPolyGridBase>)From );
	}
	
	/** 
	 * [VIuWFNgƂ̃t[ԂǉB
	 * ̎Ԃ̃f[^݂ȂΐVKɍ쐬A݂΂㏑܂B
	 * @param time ǉIuWFNg̎Ԉʒuit[ԁj
	 * @param Object w莞ԂɒǉIuWFNg
	 */
	public void	AddTimeSlot( float time, final CqMicroPolyGridBase Object )
	{
		p_int iIndex = new p_int();
		if ( iTimes() == 0 )
		{
			m_aTimes.add( time );
			m_aObjects.add( Object );
			return ;
		}
		
		if ( TimeSlotExists( time, iIndex ) )
		{
			ClearMotionObject( m_aObjects.elementAt( iIndex.value ) );
			m_aObjects.setElementAt(Object ,iIndex.value );
		}
		else
		{
			// Insert the timeslot at the proper place.
			int index = 0;
			while(index != m_aTimes.size() && m_aTimes.elementAt(index) < time )
			{
				index++;
			}
			m_aTimes.add( index, time );
			m_aObjects.add( index, Object );
		}
	}
	
	/** 
	 * [VIuWFNgwt[Ԃ̃IuWFNgƌB
	 * A̎ԈʒuɃIuWFNgȂ΁AwIuWFNĝ܂ܐVKǉB
	 * 
	 * @param time Ώۂ̃t[
	 * @param Object IuWFNg
	 */
	public void	ConcatTimeSlot( float time, final CqMicroPolyGridBase Object )
	{
		p_int iIndex = new p_int();
		if ( TimeSlotExists( time, iIndex ) )
		{
			m_aObjects.setElementAt( ConcatMotionObjects( m_aObjects.elementAt( iIndex.value ), Object ), iIndex.value );
		}
		else
		{
			// Add a new slot a nd set it to the default value before concatenating the
			// specified value.
			AddTimeSlot( time, m_DefObject );
			TimeSlotExists( time, iIndex );
			m_aObjects.setElementAt( ConcatMotionObjects( m_aObjects.elementAt( iIndex.value ), Object ), iIndex.value );
		}
	}
	
	/** 
	 * SẴ^CXbgɑ΂ĎwIuWFNg
	 * @param Object IuWFNg
	 */
	public void	ConcatAllTimeSlots( final CqMicroPolyGridBase Object )
	{
		for( int index=0; index<m_aObjects.size(); index++ ){
			m_aObjects.setElementAt( ConcatMotionObjects( m_aObjects.elementAt( index ), Object ), index );
		}
	}
	
	
	/** 
	 * wʒuɊi[Ăt[ԂԂB
	 * @param index ^CXbg̃CfbNX
	 * @return t[
	 */
	public float	Time( int index )
	{
		if ( m_aTimes.size() == 0 )
			return ( 0.0f );
		else if ( index < 0 )
			return ( m_aTimes.elementAt( 0 ) );
		else if ( index < iTimes() )
			return ( m_aTimes.elementAt( index ) );
		else
			return ( m_aTimes.lastElement() );
	}
	
	/** 
	 * ^CXbgɊi[Ă鐔ԂB
	 * @return ^CXbg̃TCY
	 */
	public int	iTimes()
	{
		return ( m_aTimes.size() );
	}
	
	/** 
	 * 
	 * ̃[VubNۂɃ[Vu[sĂ邩ۂB
	 * @return [Vu[sĂ邩ۂ
	 */
	public boolean fMotionBlurred()
	{
		return ( iTimes() > 1 );
	}
	
	/** 
	 * 
	 * wt[Ԃ^CXbgɊi[ĂCfbNXԂB<br>
	 * A̎ԂɐmɈvCfbNXȂꍇɂ́Ał߂CfbNXԂAO`P͈̔͂ł̌덷FractionɃZbgB
	 * Get the index of the timeslot for the specified time, and if not exact, the fractional
	 * distance between it and the following timeslot 0-1.
	 * 
	 * @param time I)t[
	 * @param iIndex O)^CXbg̃CfbNX
	 * @param Fraction O)덷䗦
	 * @return CfbNXmǂB
	 */
	public boolean GetTimeSlot( float time, p_int iIndex, p_float Fraction )
	{
		assert( iTimes() > 0 );
		
		if ( time >= m_aTimes.lastElement() )
		{
			iIndex.value = m_aTimes.size() - 1;
			return ( true );
		}
		else if ( time <= m_aTimes.firstElement() )
		{
			iIndex.value = 0;
			return ( true );
		}
		else
		{
			// Find the appropriate time span.
			iIndex.value = 0;
			while ( time >= m_aTimes.elementAt( iIndex.value + 1 ) )
				iIndex.value += 1;
			Fraction.value = ( time - m_aTimes.elementAt( iIndex.value ) ) / ( m_aTimes.elementAt( iIndex.value + 1 ) - m_aTimes.elementAt( iIndex.value ) );
			return ( m_aTimes.elementAt( iIndex.value ) == time );
		}
	}
	
	/** 
	 * ^CXbg̎wt[Ԃi[ĂCfbNXԂB
	 * @param time I)t[
	 * @param iIndex O)CfbNX
	 * @return CfbNX擾łǂB
	 */
	public boolean	TimeSlotExists( float time, p_int iIndex )
	{
		//assert( cTimes() > 0 );
		//assert(time>=0.0f);
		
		// Find the appropriate time span.
		iIndex.value = 0;
		while ( iIndex.value < iTimes() && time != m_aTimes.elementAt( iIndex.value ) )
			iIndex.value += 1;
		return ( iIndex.value < iTimes() );
	}
	
	/** 
	 * w莞Ԃ̃[VIuWFNg̎擾B<br>
	 * w肵ԂȂꍇAӂ̃f[^烊jAɕ⊮ꂽ[VIuWFNgԂB
	 * @param time t[
	 * @return w莞Ԃ̃[VIuWFNg
	 */
	public CqMicroPolyGridBase	GetMotionObjectInterpolated( float time )
	{
		p_int iIndex = new p_int();
		p_float Fraction = new p_float();
		if ( GetTimeSlot( time, iIndex, Fraction ) )
			return ( m_aObjects.elementAt(iIndex.value) );
		else
			return ( LinearInterpolateMotionObjects( Fraction.value, m_aObjects.elementAt(iIndex.value), m_aObjects.elementAt( iIndex.value + 1 ) ) );
	}
	
	/** 
	 * w莞Ԃ̃[VIuWFNg̎擾B<br>
	 * w肵ԂȂꍇAftHg̃[VIuWFNgԂB
	 * @param time t[
	 * @return w莞Ԃ̃[VIuWFNg
	 */
	public CqMicroPolyGridBase GetMotionObject( float time )
	{
		p_int iIndex = new p_int();
		p_float Fraction = new p_float();
		if ( GetTimeSlot( time, iIndex, Fraction ) )
			return ( m_aObjects.elementAt(iIndex.value) );
		else
		{
			assert( false );
			return ( m_DefObject );
		}
	}
	
	/** 
	 * wCfbNXɊi[Ă郂[VIuWFNgԂB
	 * @param iIndex ^CXbgiVectorj̃CfbNX
	 * @return [VIuWFNg
	 */
	public CqMicroPolyGridBase GetMotionObject( int iIndex )
	{
		assert( iIndex >= 0 && iIndex < iTimes() );
		return ( m_aObjects.elementAt(iIndex) );
	}
	
	/** 
	 * ftHg̃[VIuWFNgݒB<br>
	 * ftHg̃[VIuWFNg̓^CXbggۂ̏lȂǂɎgB
	 * @param a ftHg̃[VIuWFNg
	 */
	public void	SetDefaultObject( final CqMicroPolyGridBase a )
	{
		m_DefObject = a;
	}
	
	/** 
	 * SẴIuWFNgƃ^CXbgNAB
	 *
	 */
	public void	Reset()
	{
		m_aTimes.clear();
		for ( CqMicroPolyGridBase tmp : m_aObjects ) {
			ClearMotionObject(tmp);
		}
		m_aObjects.clear();
	}
	
}
