/// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import java.lang.reflect.Method;

import static net.cellcomputing.himawari.library.EqVariableType.type_invalid;
import static net.cellcomputing.himawari.library.EqVariableClass.class_invalid;
/**
 * 
 * 
 * 
 * @author NTT DATA Corporation
 */
public strictfp class SqParameterDeclaration {
	 public SqParameterDeclaration()
	 {
		 m_strName = "" ;
		 m_Type = new EqVariableType(type_invalid);
		 m_Class = new EqVariableClass(class_invalid);
		 m_Count = 0 ;
		 m_pCreate = null ;
		 m_strSpace = "";
	 }
	 
	 public SqParameterDeclaration( final String strName, EqVariableType Type, EqVariableClass Class, int Count,
			 Method pCreate, final String strSpace )
	  {
		 m_strName = strName ;
		 m_Type = Type;
		 m_Class = Class;
		 m_Count = Count ;
		 m_pCreate = pCreate ;
		 m_strSpace = strSpace ;
	 }
        


	 public String	m_strName;										///< Name of the parameter.
	 public EqVariableType	m_Type;									///< Type.
	 public EqVariableClass	m_Class;								///< Class.
	 public int	m_Count;											///< Array length if an array.
//	 public CqParameter* ( *m_pCreate ) ( final String strName, int Count );		///< Constructor function.
	 public Method m_pCreate;										///< Constructor function.
	 public String	m_strSpace;										///< Specification coordinate system name.
}
