// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library.cache;

import net.cellcomputing.himawari.library.RendermanInterface;

/**
 * 
 * RiMakeOcclusionṼLbV
 * 
 * @author NTT DATA Corporation
 */
public strictfp class RiMakeOcclusionCache extends RiCacheBase {

	public RiMakeOcclusionCache(int npics, String picfiles[], String shadowfile, int count, String[] tokens, Object[] values)
	{
		m_npics = npics;
		int __picfiles_length = npics;
		m_picfiles = new String[__picfiles_length];
		int __picfiles_index;
		for(__picfiles_index = 0; __picfiles_index<__picfiles_length; __picfiles_index++)
		{
//			int __picfiles_slength = strlen(picfiles[__picfiles_index]);
//			m_picfiles[__picfiles_index] = new char[ __picfiles_slength + 1 ];
//			strcpy(m_picfiles[__picfiles_index], picfiles[__picfiles_index]);
			m_picfiles[__picfiles_index] = new String(  picfiles[__picfiles_index] );
		}
//		int __shadowfile_length = strlen(shadowfile);
//		m_shadowfile = new char[ __shadowfile_length + 1 ];
//		strcpy(m_shadowfile, shadowfile);
		m_shadowfile = new String( shadowfile );
		// Copy the plist here.
		int constant_size = 1;
		int uniform_size = 1;
		int varying_size = 1;
		int vertex_size = 1;
		int facevarying_size = 1;
		CachePlist(count, tokens, values, constant_size, uniform_size, varying_size, vertex_size, facevarying_size);
	}

	@Override
	public void destruct()
	{
		super.destruct();
//		int __picfiles_length = 1;
//		int __picfiles_index;
//		for(__picfiles_index = 0; __picfiles_index<__picfiles_length; __picfiles_index++)
//		{
//			delete[](m_picfiles[__picfiles_index]);
//		}
//		delete[](m_picfiles);
//		delete[](m_shadowfile);
		// plist gets destroyed by the base class.
	}
	
	@Override
	public void ReCall()
	{
		RendermanInterface.RiMakeOcclusionV(m_npics, m_picfiles, m_shadowfile, m_count, m_tokens, m_values);
	}

	private int m_npics;
	private String[] m_picfiles;
	private String m_shadowfile;
	// plist information is stored in the base class.
	
}
