// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library.types;

/* 
A C-program for MT19937, with initialization improved 2002/1/26.
Coded by Takuji Nishimura and Makoto Matsumoto.

Before using, initialize the state by using init_genrand(seed)  
or init_by_array(init_key, key_length).

Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
All rights reserved.                          

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  3. The names of its contributors may not be used to endorse or promote 
     products derived from this software without specific prior written 
     permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


Any feedback is very welcome.
http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/emt.html
email: m-mat @ math.sci.hiroshima-u.ac.jp (remove space)
*/


/**
 * 
 * 𔭐NXB <br>
 * ufloatɑΉĂA͈̔͂w肵AύX肷邱ƂoB
 * 
 * @author NTT DATA Corporation
 */
public strictfp class CqRandom {

//	private static Random rand;
	
	//************************************************************************//
	//*** RXgN^̒`
	//************************************************************************//
	
	/**
	 * WRXgN^
	 */
	public CqRandom(){
//		rand = new Random();
	}
	
	/**
	 * ̎w肷RXgN^@<br>
	 * Aۂɂ͎ݒ肵ȂB
	 * @param Seed	̎
	 */
	public CqRandom( int Seed ){
//		rand = new Random(Seed);
		
		//Aqsisłݒ肵ĂȂ
	}
	
	//************************************************************************//
	//*** \bh̒`
	//************************************************************************//
	
	/**
	 * int^B͈͂[0,INT_MAX]@<br>
	 * ۂɂlongԂB́ACunsignendɂ̂Javaɂ͂Ȃ߂łB
	 * 
	 * @return	
	 */
	public long RandomInt(){
//		return rand.nextInt();
		return genrand_int32();
	}
    
	/**
	 * int^B͈͂[0,Range]@<br>
	 * ۂɂlongԂB́ACunsignendɂ̂Javaɂ͂Ȃ߂łB
	 * 
	 * @return	
	 */
    public long RandomInt( int Range ){
//    	return rand.nextInt( Range );
        double n = RandomFloat( Range );
        return Math.round(n);
    }
    
    /**
     * float^B͈͂[0,1)
     * 
     * @return	
     */
    public float RandomFloat(){
//    	return (float)rand.nextDouble();
    	return (float)genrand_real2();
    }

    /**
     * float^B͈͂[0,Range)
     * 
     * @return	
     */
    public float RandomFloat( float Range ){
//    	return (float)rand.nextDouble() * Range;
    	return ((float)genrand_real2()* Range);
    }
   
    /**
     * ̎Đݒ肷 
     * 
     * @param Seek	ݒ肵m̎
     */
    public void Reseed( int Seek ){
//    	rand.setSeed( Seek );
    	init_genrand( Seek);
    }
    
    
    
    private static final int N	= 624;
    private static final int M	= 397;
    private static final long MATRIX_A	= 0x9908b0dfL;   /* constant vector a */
    private static final long UPPER_MASK	= 0x80000000L;   /* most significant w-r bits */
    private static final long LOWER_MASK	= 0x7fffffffL;   /* least significant r bits */

    private static long[] mt = new long[N];   /* the array for the state vector  */
    private static int   mti = N+1;
    
    /* initializes mt[N] with a seed */
    /* w肳ꂽ̎ŗz */
    private static void init_genrand(long s)
    {
        mt[0]= s & 0xffffffffL;
        for (mti=1; mti<N; mti++) {
            mt[mti] =
                (1812433253L * (mt[mti-1] ^ (mt[mti-1] >> 30)) + mti);
            /* See Knuth TAOCP Vol2. 3rd Ed. P.106 for mLtiplier. */
            /* In the previous versions, MSBs of the seed affect   */
            /* only MSBs of the array mt[].                        */
            /* 2002/01/09 modified by Makoto Matsumoto             */
            mt[mti] &= 0xffffffffL;
            /* for >32 bit machines */
        }
    }

//    /* initialize by an array with array-length */
//    /* init_key is the array for initializing keys */
//    /* key_length is its length */
//    /* slight change for C++, 2004/2/26 */
//    /* w肵zŗz */
//    private static void init_by_array(long init_key[], int key_length)
//    {
//        int i, j, k;
//        init_genrand(19650218L);
//        i=1; j=0;
//        k = (N>key_length ? N : key_length);
//        for (; k>=1; k--) {
//            mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1664525L))
//                    + init_key[j] + j; /* non linear */
//            mt[i] &= 0xffffffffL; /* for WORDSIZE > 32 machines */
//            i++; j++;
//            if (i>=N) { mt[0] = mt[N-1]; i=1; }
//            if (j>=key_length) j=0;
//        }
//        for (k=N-1; k>=1; k--) {
//            mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1566083941L))
//                    - i; /* non linear */
//            mt[i] &= 0xffffffffL; /* for WORDSIZE > 32 machines */
//            i++;
//            if (i>=N) { mt[0] = mt[N-1]; i=1; }
//        }
//
//        mt[0] = 0x80000000L; /* MSB is 1; assuring non-zero initial array */
//    }

//    private static int count = 0;
    private static long[]  mag01 = new long[]{0x0L, MATRIX_A};
    
    /* generates a random number on [0,0xffffffff]-erval */
    /* [0,0xffffffff]͈̔͂ŗ𔭐 */
    private static long genrand_int32()
    {
        long  y;
        /* mag01[x] = x * MATRIX_A  for x=0,1 */

        if (mti >= N) { /* generate N words at one time */
            int kk;

            if (mti == N+1)   /* if init_genrand() has not been called, */
                init_genrand(5489L); /* a defaLt initial seed is used */

            for (kk=0;kk<N-M;kk++) {
                y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
                mt[kk] = mt[kk+M] ^ (y >> 1) ^ mag01[(int)(y & 0x1L)];
            }
            for (;kk<N-1;kk++) {
                y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
                mt[kk] = mt[kk+(M-N)] ^ (y >> 1) ^ mag01[(int)(y & 0x1L)];
            }
            y = (mt[N-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
            mt[N-1] = mt[M-1] ^ (y >> 1) ^ mag01[(int)(y & 0x1L)];

            mti = 0;
        }

        y = mt[mti++];

        /* Tempering */
        y ^= (y >> 11);
        y ^= (y << 7) & 0x9d2c5680L;
        y ^= (y << 15) & 0xefc60000L;
        y ^= (y >> 18);

        return y;
    }

//    /* generates a random number on [0,0x7fffffff]-erval */
//    /* [0,0x7fffffff]͈̔͂ŗ𔭐 */
//    private static long genrand_int31()
//    {
//        return (long)(genrand_int32()>>1);
//    }
//
//    /* generates a random number on [0,1]-real-erval */
//    /* [0,1]͈̔͂ŗ𔭐 */
//    private static double genrand_real1()
//    {
//        return genrand_int32()*(1.0/4294967295.0);
//        /* divided by 2^32-1 */
//    }

    /* generates a random number on [0,1)-real-erval */
    /* [0,1)͈̔͂ŗ𔭐 */
    private static double genrand_real2()
    {
        return genrand_int32()*(1.0/4294967296.0);
        /* divided by 2^32 */
    }

//    /* generates a random number on (0,1)-real-erval */
//    /* (0,1)͈̔͂ŗ𔭐 */
//    private  static double genrand_real3()
//    {
//        return (((double)genrand_int32()) + 0.5)*(1.0/4294967296.0);
//        /* divided by 2^32 */
//    }
//
//    /* generates a random number on [0,1) with 53-bit resolution*/
//    /* [0,1)͈̔͂ŗ𔭐 */
//    private static double genrand_res53()
//    {
//        long a=genrand_int32()>>5, b=genrand_int32()>>6;
//        return(a*67108864.0+b)*(1.0/9007199254740992.0);
//    }
	
}
