/*
 KeywordMakeCubeFaceEnvironment.java
 Copyright (C) 2003 Gerardo Horvilleur Martinez

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.parser.keywords;

import java.lang.reflect.Method;

import net.cellcomputing.himawari.library.RendermanInterface;
import net.cellcomputing.himawari.parser.Global;
import net.cellcomputing.himawari.parser.Tokenizer;

public strictfp class KeywordMakeCubeFaceEnvironment extends AbstractKeywordParser {

    public void parse(Tokenizer st) throws Exception {
        // Expect px
        match(st, TK_STRING);
        String px = st.sval;
        
        // Expect nx
        match(st, TK_STRING);
        String nx = st.sval;
        
        // Expect py
        match(st, TK_STRING);
        String py = st.sval;
        
        // Expect ny
        match(st, TK_STRING);
        String ny = st.sval;
       
        // Expect pz
        match(st, TK_STRING);
        String pz = st.sval;
        
        // Expect nz
        match(st, TK_STRING);
        String nz = st.sval;
        
        // Expect texturename
        match(st, TK_STRING);
        String reflfile = st.sval;
        
        // Expect fov
        match(st, TK_NUMBER);
        float fov = (float)st.nval;
        
        // Expect filter
        match(st, TK_STRING);
        String filtername = Global.GetFilterFunction( st.sval ); 
        Method filterfunc = RendermanInterface.class.getMethod( filtername, float.class, float.class, float.class, float.class);
    
        // Expect swidth
        match(st, TK_NUMBER);
        float swidth = (float)st.nval;
        
        // Expect twidth
        match(st, TK_NUMBER);
        float twidth = (float)st.nval;
        
        // Expect parameter list
        parseParameterList(st);
     
        RendermanInterface.RiMakeCubeFaceEnvironmentV( px, nx, py, ny, pz, nz, reflfile, fov, 
        								filterfunc, swidth, twidth, count(), tokens(), values() );
    }

}
